
// Programme pour Arduino Max7456 et capteur Pression temperature BMP1085
// Pour OSD déstiné au relais ATV du mont Poupet
// Auxiliaires 1  &  2
// F5MNA le 12/03/2012  
// Modif le 11/05/12: Espace comblé après la temperature et C° suite à bugg.  OSD_write_to_screen(" ^",8,2,0,0);
// Modif le 11/03/2014 : Modif Clear screan & affichages statiques dans le setup.
// Le nombre 500 de la ligne suivante est à modifier dans le programme selon l'altitude de la sonde
// afin d'indiquer la pression relative par rapport au niveau de la mer.
// float pressure = bmp085GetPressure(bmp085ReadUP())+ 6024; //6024 = 500/8.3  // correction 500 m 

// Connexion VCC du BMP085 au 3.3V (Pas au 5.0V!)
// Connexion GND à la masse 
// Connexion SCL à i2c clock -  Analog 5
// Connexion SDA à i2c data -  Analog 4

//F5MNA    Site http://f5mna.free.fr

#define DATAOUT 11//MOSO
#define DATAIN  12//MISI
#define SPICLOCK  13//sck
#define MAX7456SELECT 10//ss
#define VSYNC 2// INT0

#define DMM_reg   0x04
#define DMAH_reg  0x05
#define DMAL_reg  0x06
#define DMDI_reg  0x07
#define VM0_reg   0x00
#define VM1_reg   0x01


#define VIDEO_BUFFER_DISABLE 0x01
#define MAX7456_RESET 0x02
#define VERTICAL_SYNC_NEXT_VSYNC 0x04
#define OSD_ENABLE 0x08
#define SYNC_MODE_AUTO 0x00
#define SYNC_MODE_INTERNAL 0x30
#define SYNC_MODE_EXTERNAL 0x20
#define VIDEO_MODE_PAL 0x40
#define VIDEO_MODE_NTSC 0x00

#define BLINK_DUTY_CYCLE_50_50 0x00
#define BLINK_DUTY_CYCLE_33_66 0x01
#define BLINK_DUTY_CYCLE_25_75 0x02
#define BLINK_DUTY_CYCLE_75_25 0x03

#define BLINK_TIME_0 0x00
#define BLINK_TIME_1 0x04
#define BLINK_TIME_2 0x08
#define BLINK_TIME_3 0x0C


#define BACKGROUND_BRIGHTNESS_0 0x00
#define BACKGROUND_BRIGHTNESS_7 0x01
#define BACKGROUND_BRIGHTNESS_14 0x02
#define BACKGROUND_BRIGHTNESS_21 0x03
#define BACKGROUND_BRIGHTNESS_28 0x04
#define BACKGROUND_BRIGHTNESS_35 0x05
#define BACKGROUND_BRIGHTNESS_42 0x06
#define BACKGROUND_BRIGHTNESS_49 0x07

#define BACKGROUND_MODE_GRAY 0x40


#define CLEAR_display 0x04
#define CLEAR_display_vert 0x06
#define END_string 0xff


#define ENABLE_display 0x48
#define ENABLE_display_vert 0x4c
#define MAX7456_reset 0x42
#define DISABLE_display 0x40


#define WHITE_level_80 0x03
#define WHITE_level_90 0x02
#define WHITE_level_100 0x01
#define WHITE_level_120 0x00

// with PAL
#define MAX_screen_size 480
#define MAX_screen_rows 16
                
  // Initialisation de la sortie de commande relais
  // Pin 8 reliée à la platine relais:
  const int Video1 = 3;   // Cde video 1
  const int Video2 = 4;   // Cde Video2
  const int Relais = 8;   // Cde relais video
 // variables selon ordre sur video 1 ou video2:
  // variables selon ordre sur video 1 ou video2:
  int Choixcam1 = 0;   
  int Choixcam2 = 0; 
  
// concerne capteur BMP1085
  
#include <Wire.h>
#include <floatToString.h> 


#define BMP085_ADDRESS 0x77  // I2C address of BMP085

const unsigned char OSS = 0; 

// Valeur calibration
int ac1;
int ac2;
int ac3;
unsigned int ac4;
unsigned int ac5;
unsigned int ac6;
int b1;
int b2;
int mb;
int mc;
int md;

// Comparaison Pression
word P1;
int Cpte;
float P2;
float P3;
float P4;
int Tendance;

long b5; 
int Temper; //temperature

//////////////////////////////////////////////////////////////
  void setup() {
   
  // initialise les entrées de cde video:
  pinMode(Video1, INPUT); 
  pinMode(Video2, INPUT);  
  // initialise la sortie 8 de la cde du relais
  pinMode(Relais, OUTPUT);   
  digitalWrite(Relais, HIGH);
  //initialisation des sorties LED
  pinMode(5, OUTPUT); // Cde Vidéo1
  pinMode(6, OUTPUT); // Cde Vidéo2
  
  
  byte spi_junk, eeprom_junk;
  int x;
 ///////////////////////////////////
 // Serial.begin(9600);
 // Serial.flush();
 ///////////////////////////////////
  pinMode(MAX7456SELECT,OUTPUT);
  digitalWrite(MAX7456SELECT,HIGH); 

  pinMode(DATAOUT, OUTPUT);
  pinMode(DATAIN, INPUT);
  pinMode(SPICLOCK,OUTPUT);
  pinMode(VSYNC, INPUT);

  SPCR = (1<<SPE)|(1<<MSTR);
  spi_junk=SPSR;
  spi_junk=SPDR;
  delay(250);


  digitalWrite(MAX7456SELECT,LOW);
  spi_transfer(VM0_reg);
  spi_transfer(MAX7456_reset);
  digitalWrite(MAX7456SELECT,HIGH);
  delay(500);

  digitalWrite(MAX7456SELECT,LOW);
  for (x = 0; x < MAX_screen_rows; x++)
  {
    spi_transfer(x + 0x10);
    spi_transfer(WHITE_level_90);
  }

  // make sure the Max7456 is enabled
  spi_transfer(VM0_reg);
  spi_transfer(VERTICAL_SYNC_NEXT_VSYNC|OSD_ENABLE);
  digitalWrite(MAX7456SELECT,HIGH);
  delay(100);

  spi_transfer(VM1_reg);
  spi_transfer(BLINK_DUTY_CYCLE_50_50|BLINK_TIME_3); 
  
  digitalWrite(MAX7456SELECT,HIGH);
  
  digitalWrite(Relais, LOW);
  digitalWrite(6, HIGH);
  digitalWrite(5, LOW);
    
  Wire.begin();
  P1 = 0;
  Cpte = 0;
  P2 = 0;
  P3 = 0;
  P4 = 0;
  Tendance = 0;
  bmp085Calibration();
  OSD_write_to_screen(" HTTP://F5MNA.FREE.FR",4,13,0,1); 
  OSD_write_to_screen("¨",15,2,0,0);
  delay (10);
   }
 /////////////////////////////////////////////////////////////
void loop() 
{
   spi_transfer(VM0_reg);
   spi_transfer(VERTICAL_SYNC_NEXT_VSYNC|OSD_ENABLE|SYNC_MODE_AUTO);
   digitalWrite(MAX7456SELECT,HIGH); 
  
  Choixcam1 = digitalRead(Video1);
  Choixcam2 = digitalRead(Video2);
  
   // Bascule relais video  
  if ((Choixcam2 == HIGH) and (Choixcam1 == LOW)) {
     digitalWrite(Relais, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(6, LOW);
       // clear the screen
     digitalWrite(MAX7456SELECT,LOW);
     spi_transfer(DMM_reg);
     spi_transfer(CLEAR_display);
     digitalWrite(MAX7456SELECT,HIGH);
   }

   if ((Choixcam1 == HIGH)and (Choixcam2 == LOW)){
     digitalWrite(Relais, LOW);
     digitalWrite(6, HIGH);
     digitalWrite(5, LOW);
     
  }
  
  float temperature = bmp085GetTemperature(bmp085ReadUT()); 
  float pressure = bmp085GetPressure(bmp085ReadUP())+ 6024 ; // correction Poupet 850 m (850/8.3)*100 = 10240
  //6024 = (500/8.3)*100   correction 500 m 
  //(850/8.3)*100 = 10240 correction 850 m 
  float atm = pressure / 101325; // Atmosphere standard
  //float altitude = calcAltitude(pressure); // Calcul de l'altitude non compensée - en Metres   
   
   //passage float en string  Pression
   char Pression1[25]; 
   (floatToString(Pression1, P2, 0));
   
   //passage float en string  Temperature
   char Temp1[25]; 
   (floatToString(Temp1, temperature, 1));
  
  
  P3 = (pressure/100);
  P1 = P1 + 1;
  //Serial.println (P1);
  if (P1 == 1)  {P2 = pressure/100;}
  if (P1 > 36000)  {Cpte = Cpte +1;}
  
  if (Cpte > 1){ 
  P4 = (P3-P2);
  if ((P4 > -0.41) or (P4 < 0.41))    {Tendance = 1;}
  if (P4 > 0.4)   {Tendance = 2;}
  if (P4 < - 0.4)   {Tendance = 3;}
  Cpte = 0;
  }
  if (Cpte > 1) { Cpte = 0;} 
  if (P1 > 36000) { P1 = 0;} 
//////////////////////////////////////////////////////////
    // passage integer à string
    //char Compte[10]; //char array of string 
    //itoa(Cpte,Compte, 10); 
    //Serial.print  (Compte);
////////////////////////////////////////////////////////////

  if (digitalRead(8) == LOW)
  {  
  if (Temper < -9 ) OSD_write_to_screen(Temp1,2,2,0,0);
  
  if ((Temper < 10) and (Temper > 0))
  { OSD_write_to_screen(" ",3,2,0,0);
    OSD_write_to_screen(Temp1,4,2,0,0);}
  else
   {OSD_write_to_screen(Temp1,3,2,0,0);}
  
  OSD_write_to_screen(" ^",7,2,0,0);

    
  OSD_write_to_screen(Pression1,18,2,0,0);
  OSD_write_to_screen("hPa",23,2,0,0);
    
  if (Tendance == 1){OSD_write_to_screen("¨",15,2,0,0);}
                      
  if (Tendance == 2){OSD_write_to_screen("{",16,2,0,0);}
                     
  if (Tendance == 3){OSD_write_to_screen("}",16,2,0,0);}
 
  delay(100); //Attente 0.1 s

}
}

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
byte convert_ascii (int character)
{
// Transposition de la table ASCII (non standard) integrée à l'EEPROM du MAX7456
// f5mna_4.mcm
 byte lookup_char;

  if (character == 32)
    lookup_char = 0x00; // blank space
  else if (character == 48)
    lookup_char = 0x0a; // 0
  else if ((character > 48) && (character < 58))
    lookup_char = (character - 48); // 1-9
  else if ((character > 64) && (character < 91))
    lookup_char = (character - 54); // A-Z
  else if ((character > 96) && (character < 123))
    lookup_char = (character - 60); // a-z
  else if (character == 34)
    lookup_char = 0x48; // "
  else if (character == 39)
    lookup_char = 0x46; // '
  else if (character == 40)
    lookup_char = 0x3f; // (
  else if (character == 41)
    lookup_char = 0x40; // )
  else if (character == 44)
    lookup_char = 0x45; // ,
  else if (character == 45)
    lookup_char = 0x49; // -
  else if (character == 46)
    lookup_char = 0x41; // .
  else if (character == 47)
    lookup_char = 0x47; // /
  else if (character == 58)
    lookup_char = 0x44; // :
  else if (character == 59)
    lookup_char = 0x43; // ;
  else if (character == 60)
    lookup_char = 0x4a; // <
  else if (character == 62)
    lookup_char = 0x4b; // >
  else if (character == 63)
    lookup_char = 0x42; // ?
  else if (character == 64)
    lookup_char = 0x4c; // @
 //Modif tableau Std:  f5mna_3.mcm  
 //*********************************   
  else if (character == 43)
    lookup_char = 0x4e; // + 
  else if (character == 42)
    lookup_char = 0x4d ; // *    
  else if (character == 35)
    lookup_char = 0x51 ; // #    
  else if (character == 176)
    lookup_char = 0x4f ; // °     
  else if (character == 94)//^
    lookup_char = 0x50 ; // °C
 //********************************* 
 //    FLECHES  f5mna_4.mcm
 //********************************
  else if (character == 123) //Fléche montante
    lookup_char = 0x52 ;    // {  
  else if (character == 125)//Flèche descendante
    lookup_char = 0x53 ;    //}     
  else if (character == 168) //Flèche horizontale
    lookup_char = 0x54 ;    // ¨ tréma



  else
    lookup_char = 0x00; // out of range, blank space

 return (lookup_char);

}
//////////////////////////////////////////////////////////////
byte spi_transfer(volatile byte data)
{
  SPDR = data;			  
  while (!(SPSR & (1<<SPIF)))     
  {
  };
  return SPDR;			 

}

// ================   WRITE TO SCREEN
void OSD_write_to_screen(const char s[], byte x, byte y, byte blink, byte invert){
  unsigned int linepos;
  byte local_count;
  byte settings, char_address_hi, char_address_lo;
  byte screen_char;
  
  local_count = 0;
  
  char_address_hi = 0;
  char_address_lo = 0;
  
  linepos = y*30+x;

  char_address_hi = linepos >> 8;
  char_address_lo = linepos;

  settings = B00000001;

  if (blink) {
    settings |= (1 << 4);
    }

  if (invert){
    settings |= (1 << 3);	
  }


  digitalWrite(MAX7456SELECT,LOW);

  spi_transfer(DMM_reg); 
  spi_transfer(settings);

  spi_transfer(DMAH_reg); 
  spi_transfer(char_address_hi);

  spi_transfer(DMAL_reg); 
  spi_transfer(char_address_lo);


  while(s[local_count]!='\0') 
  {
    screen_char = s[local_count];
    screen_char= convert_ascii(screen_char);
    spi_transfer(DMDI_reg);
    spi_transfer(screen_char);
    local_count++;
  }
  
  spi_transfer(DMDI_reg);
  spi_transfer(END_string);

  spi_transfer(VM0_reg);
  spi_transfer(ENABLE_display_vert);
  digitalWrite(MAX7456SELECT,HIGH);
  }
  void bmp085Calibration()
{
  ac1 = bmp085ReadInt(0xAA);
  ac2 = bmp085ReadInt(0xAC);
  ac3 = bmp085ReadInt(0xAE);
  ac4 = bmp085ReadInt(0xB0);
  ac5 = bmp085ReadInt(0xB2);
  ac6 = bmp085ReadInt(0xB4);
  b1 = bmp085ReadInt(0xB6);
  b2 = bmp085ReadInt(0xB8);
  mb = bmp085ReadInt(0xBA);
  mc = bmp085ReadInt(0xBC);
  md = bmp085ReadInt(0xBE);
}


float bmp085GetTemperature(unsigned int ut){
  long x1, x2;

  x1 = (((long)ut - (long)ac6)*(long)ac5) >> 15;
  x2 = ((long)mc << 11)/(x1 + md);
  b5 = x1 + x2;

  float temp = ((b5 + 8)>>4);
  temp = temp /10;
  Temper = temp;
  return temp;
}

long bmp085GetPressure(unsigned long up){
  long x1, x2, x3, b3, b6, p;
  unsigned long b4, b7;

  b6 = b5 - 4000;
  // Calculate B3
  x1 = (b2 * (b6 * b6)>>12)>>11;
  x2 = (ac2 * b6)>>11;
  x3 = x1 + x2;
  b3 = (((((long)ac1)*4 + x3)<<OSS) + 2)>>2;

  // Calculate B4
  x1 = (ac3 * b6)>>13;
  x2 = (b1 * ((b6 * b6)>>12))>>16;
  x3 = ((x1 + x2) + 2)>>2;
  b4 = (ac4 * (unsigned long)(x3 + 32768))>>15;

  b7 = ((unsigned long)(up - b3) * (50000>>OSS));
  if (b7 < 0x80000000)
    p = (b7<<1)/b4;
  else
    p = (b7/b4)<<1;

  x1 = (p>>8) * (p>>8);
  x1 = (x1 * 3038)>>16;
  x2 = (-7357 * p)>>16;
  p += (x1 + x2 + 3791)>>4;

  long temp = p;
  return temp;
}

char bmp085Read(unsigned char address)
{
  unsigned char data;

  Wire.beginTransmission(BMP085_ADDRESS);
  Wire.write(address);
  Wire.endTransmission();

  Wire.requestFrom(BMP085_ADDRESS, 1);
  while(!Wire.available())
    ;

  return Wire.read();
}

int bmp085ReadInt(unsigned char address)
{
  unsigned char msb, lsb;

  Wire.beginTransmission(BMP085_ADDRESS);
  Wire.write(address);
  Wire.endTransmission();

  Wire.requestFrom(BMP085_ADDRESS, 2);
  while(Wire.available()<2)
    ;
  msb = Wire.read();
  lsb = Wire.read();

  return (int) msb<<8 | lsb;
}


unsigned int bmp085ReadUT(){
  unsigned int ut;

  Wire.beginTransmission(BMP085_ADDRESS);
  Wire.write(0xF4);
  Wire.write(0x2E);
  Wire.endTransmission();

  delay(5);

  ut = bmp085ReadInt(0xF6);
  return ut;
}

unsigned long bmp085ReadUP(){

  unsigned char msb, lsb, xlsb;
  unsigned long up = 0;

  Wire.beginTransmission(BMP085_ADDRESS);
  Wire.write(0xF4);
  Wire.write(0x34 + (OSS<<6));
  Wire.endTransmission();

  delay(2 + (3<<OSS));

  msb = bmp085Read(0xF6);
  lsb = bmp085Read(0xF7);
  xlsb = bmp085Read(0xF8);

  up = (((unsigned long) msb << 16) | ((unsigned long) lsb << 8) | (unsigned long) xlsb) >> (8-OSS);

  return up;
}

void writeRegister(int deviceAddress, byte address, byte val) {
  Wire.beginTransmission(deviceAddress); 
  Wire.write(address);
  Wire.write(val); 
  Wire.endTransmission(); 
}

int readRegister(int deviceAddress, byte address){

  int v;
  Wire.beginTransmission(deviceAddress);
  Wire.write(address); 
  Wire.endTransmission();

  Wire.requestFrom(deviceAddress, 1); 

  while(!Wire.available()) {
  
  }

  v = Wire.read();
  return v;
}

float calcAltitude(float pressure){

  float A = pressure/101325;
  float B = 1/5.25588;
  float C = pow(A,B);
  C = 1 - C;
  C = C /0.0000225577;

  return C;
}
